PSDU_LENGTH = 400;
mode = 54;  % 6, 9 , 12, 18, 24, 36, 48, 54
N_packets = 300;
channel_model = 'AWGN';
enable_hpa = 1;
enable_ndc = 1;
enable_fec = 1;
A_sat = 2.3;

Fs = 20;
L = 5;

min_packet_errors = 50;
min_packets = 200;

% For 54/48Mbps mode    
%SNR = [12.5 15 17.5 20 22.5 25 27.5 30 32.5 35];
SNR = [10 12.5 15 16.25 17.5 18.75 20 21.25 22.5 25 30 35];

%SNR = [20 22.5 25 30]; 
%SNR = [25]; 
% For 36Mbps mode    
%SNR = [5 7.5 10 11.25 12.5 13.75 15 17.5 20 22.5 25 27.5 30];
% For 24Mbps mode    
%SNR = [3 6 8 9 10 11.25 12.5 15 17.5 20 25];
%SNR = 11.25;

%SNR = [10 12.5 15 17.5 20 22.5 25 30 35];
%SNR = [7.5 10 12.5 15 17.5 20 25 30];
%SNR = [0 1 2 3 4 5 6 7];

%SNR = [7.5 10 11.25 12.5 13.75 15 17.5 20];

%SNR = 250;

BER_lin = zeros(size(SNR));
PER_lin = zeros(size(SNR));
BER_nln = zeros(size(SNR));
PER_nln = zeros(size(SNR));
BER_ndc = zeros(size(SNR));
PER_ndc = zeros(size(SNR));
BER_fec = zeros(size(SNR));
PER_fec = zeros(size(SNR));


for u=1:length(SNR),
    
    
    for trial_no=1:3,
        
        if trial_no==1,
            enable_hpa = 0;
            enable_ndc = 0;
            enable_fec = 0;
            G_fec = 0;
        elseif trial_no==2,
            enable_hpa = 1;
            enable_ndc = 0;
            enable_fec = 0;
            G_fec = 0;
        elseif trial_no==3,
            enable_hpa = 1;
            enable_ndc = 1;
            enable_fec = 0;
            G_fec = 0;
        end
        
        c_hat = [];
        
        BER = 0;
        PER = 0;
        
        N_packets_final = N_packets;

        obo = 0;

        for pak = 1:N_packets,
            
            data_psdu = randi([0 1], 1, PSDU_LENGTH*8);
            
            tx_out = tx_burst(data_psdu, mode);
            
            tx_upsample = resample(tx_out, L, 1, 10);
            
            
            if enable_hpa == 1,
                if mode==36 || mode==24,
                    STD_norm = 0.10938;
                elseif mode==48 || mode==54,
                    STD_norm = 0.10755;
                elseif mode==12 || mode==18,
                    STD_norm = 0.11048;
                elseif mode==6 || mode==9,
                    STD_norm = 0.11137;
                end
                A_sat_norm = A_sat*STD_norm; %std(tx_upsample);
                tx_nln = hpa_model_rapp(tx_upsample, A_sat_norm, 2);
                obo = obo + 10*log10(A_sat_norm.^2 / mean(abs(tx_nln).^2));

            else
                tx_nln = tx_upsample;
            end
            
            %f_msk = [0 9 11 20 30 Fs*L/2 Fs*L-30 Fs*L-20 Fs*L-11 Fs*L-9 Fs*L];
            %p_msk = [0 0 -20 -28 -40 -40 -40 -28 -20 0 0];
            %plot(f_msk, p_msk, 'r');
            %hold on
            %psd(tx_nln/std(tx_nln)/sqrt(6.5), 512, Fs*L)
           
            % Multipath channel
            tx_ch = multipath_channel(tx_nln, channel_model, SNR(u), L);
   
            % RX front end
            rx_in = resample(tx_ch, 2, L, 10);
            c_hat = [];
            [data_out, c_hat] = rx_demod7b(rx_in, mode, PSDU_LENGTH, enable_ndc, c_hat, enable_ndc*enable_fec, G_fec);
            
            
            ber_pak = sum((data_psdu - data_out)~=0) / length(data_psdu);
            per_pak = (ber_pak>0)*1;
            
                         
            if per_pak>0,
                fprintf('*');
            else
                fprintf('.');
            end
            
            
            
            BER = BER + ber_pak;
            PER = PER + per_pak;
            
            % Check if we already get half of expected packet errors
            % and let our simulation run twice as long as till now
            if (pak>=min_packets/2) && (PER > min_packet_errors/2) && (N_packets_final==N_packets), 
                N_packets_final = 2*pak;
            end
            
            if mod(pak,60)==0,
                fprintf('\n');
            end
            
            if pak >= N_packets_final,
                break;
            end
            
        end
        
        fprintf('\n');
        
        
        N_packets_final = min([N_packets N_packets_final]);
        
        BER = BER / N_packets_final;
        PER = PER / N_packets_final;
        
        fprintf('Trial: %i | SNR=%2.2f | BER=%2.8f | PER=%2.8f | OBO = %2.8f\n', trial_no, SNR(u), BER, PER, obo/N_packets_final);

        if trial_no==1,
            BER_lin(u) = BER;
            PER_lin(u) = PER;
        elseif trial_no==2,
            BER_nln(u) = BER;
            PER_nln(u) = PER;
        elseif trial_no==3,
            BER_ndc(u) = BER;
            PER_ndc(u) = PER;
        elseif trial_no==4,
            BER_fec(u) = BER;
            PER_fec(u) = PER;    
        end
        
    end
    
    semilogy(SNR, BER_lin, 'b-o');
    hold on
    semilogy(SNR, PER_lin, 'r--o');
    semilogy(SNR, BER_nln, 'b-v');
    semilogy(SNR, PER_nln, 'r--v');
    semilogy(SNR, BER_ndc, 'b-*');
    semilogy(SNR, PER_ndc, 'r--*');  
    hold off
    pause(0.1)
    
end

% semilogy(SNR, BER_lin, 'b-o');
% hold on
% semilogy(SNR, PER_lin, 'r--o');
% semilogy(SNR, BER_nln, 'b-v');
% semilogy(SNR, PER_nln, 'r--v');
% semilogy(SNR, BER_ndc, 'b-*');
% semilogy(SNR, PER_ndc, 'r--*');
% semilogy(SNR, BER_fec, 'b-d');
% semilogy(SNR, PER_fec, 'r--d');   

save results.mat SNR BER_lin PER_lin BER_nln PER_nln BER_ndc PER_ndc A_sat N_packets mode channel_model

